using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_Contabilidad._0_Modelos;
using Exferia_Aplicacion.Modelos_MantenimientoSimple;
using System.Transactions;
using System.Data.SqlClient;
using System.Linq.Expressions;
using System.ComponentModel;
using static Exferia_Aplicacion.General.Enumerados;
using System.Threading;
using Exferia_Aplicacion.Modelos_Contabilidad;

namespace Exferia_Contabilidad._1_Datos
{
    class CTA_InformesContablesLineaAcumulados_Datos : ABS_Datos
    {
        #region Listado
        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }

        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;

        }

        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Obtener
        #region Obtener principal
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 1;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
            
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                    " SELECT " +
                        nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.id) + " , " +
                        nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.idInformeContableLinea) + " , " +
                        nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.idInformeContableLinea_Operacion) + " , " +
                        nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.linea) + " , " +
                        nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.calculo_valor) + " , " +
                        nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.calculo_operacion) + " , " +
                        nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.operacion) + " , " +
                        nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.fechaActualizacionInterna) + " , " +
                        nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.fechaBorrado) + 
                    " FROM " + nameof(CTA_InformesContablesLineaAcumulados) +
                    " WHERE " + nameof(CTA_InformesContablesLineaAcumulados.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<CTA_InformesContablesLineaAcumulados>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //CTA_InformesContablesLinea ##########################################################################################
                    ThreadStart obj_ThreadStart_INFORMECONTABLELINEAOPERACION = new ThreadStart(Obtener_InformeContableLineaOperacion_Modelo_Obtener);
                    Thread obj_Thread_INFORMECONTABLELINEAOPERACION = new Thread(obj_ThreadStart_INFORMECONTABLELINEAOPERACION);
                    obj_Thread_INFORMECONTABLELINEAOPERACION.Start();
                    

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaAcumulados_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }
        #region Tablas Relacionadas
        private void Obtener_InformeContableLineaOperacion_Modelo_Obtener()
        {
            try
            {
                CTA_InformesContablesLinea_Datos obj_CTA_InformesContablesLinea_Datos = new CTA_InformesContablesLinea_Datos();
                g_dnm_Modelo_Obtener.CTA_InformesContablesLinea1 = obj_CTA_InformesContablesLinea_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idInformeContableLinea_Operacion);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }

        public int Obtener_UltimoNumeroLinea(long _lng_idInformeContableLinea)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            int int_Linea = 0;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                 string str_SQL =
                                " SELECT TOP 1 " +
                                    nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.linea) +
                                " FROM " + nameof(CTA_InformesContablesLineaAcumulados) +
                                " WHERE " + nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.fechaBorrado) + " is null and " +
                                            nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.idInformeContableLinea) + "=@idInformeContableLinea " +
                                " ORDER BY " + nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.linea) + " DESC ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idInformeContableLinea",  _lng_idInformeContableLinea)
                };

                int? int_linea_AUX = obj_Exferia_Entities.Database.SqlQuery<int>(str_SQL, arr_Parametros).FirstOrDefault();

                if (int_linea_AUX != null)
                {
                    int_Linea = int_linea_AUX.Value;
                }

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaAcumulados_Datos) + "/" + nameof(Obtener_UltimoNumeroLinea), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return int_Linea;
        }

        public bool Existe_NumeroLinea(long _lng_idInformeContableLinea, long _lng_idInformeContableLineaAcumulado_Obviar, int _int_Linea)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            bool bol_Existe = false;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                                " SELECT TOP 1 " +
                                    nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.id) +
                                " FROM " + nameof(CTA_InformesContablesLineaAcumulados) +
                                " WHERE " + nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.fechaBorrado) + " is null and " +
                                            nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.id) + "<>@id and " +
                                            nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.idInformeContableLinea) + "=@idInformeContableLinea and " +
                                            nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.linea) + "=@linea ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_idInformeContableLineaAcumulado_Obviar),
                     new SqlParameter("@idInformeContableLinea",  _lng_idInformeContableLinea),
                     new SqlParameter("@linea",  _int_Linea)
                };

                long? lng_Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL, arr_Parametros).FirstOrDefault();

                if (lng_Id != null && lng_Id.Value > 0)
                {
                    bol_Existe = true;
                }

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaAcumulados_Datos) + "/" + nameof(Existe_NumeroLinea), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return bol_Existe;
        }

        #region Para Listado
        public List<INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo> Obtener_Registros_Para_Listado_Por_IdInformeContableLinea(long _lng_idInformeContableLinea)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            List<INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo> lst_INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                string str_SQL = Obtener_Consulta_Para_Listado();

                string str_Where =  nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.fechaBorrado) + " is null and " +
                                    nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.idInformeContableLinea) + "=@idInformeContableLinea";

                str_SQL = str_SQL.Replace("XXXXXXXXXX", str_Where);

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idInformeContableLinea",  _lng_idInformeContableLinea)
                };

                //Rellenar el Modelo
                lst_INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo = obj_Exferia_Entities.Database.SqlQuery<INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo>(str_SQL, arr_Parametros).ToList();
                
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaAcumulados_Datos) + "/" + nameof(Obtener_Registros_Para_Listado_Por_IdInformeContableLinea), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo;
        }
        public List<INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo> Obtener_Registros_Para_Listado_Por_UltimaFechaActualizacion(long _lng_idInformeContableLinea, DateTime? _dtt_Ultima_FechaActualizacion)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            List<INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo> lst_INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                string str_SQL = Obtener_Consulta_Para_Listado();

                
                //where
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();
                lst_Parametros.Add(new SqlParameter("@idInformeContableLinea", _lng_idInformeContableLinea));

                string str_Where =  " (not " + nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.fechaActualizacionInterna) + "  is null) AND " + 
                                    nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.idInformeContableLinea) + " =@idInformeContableLinea ";

                if (_dtt_Ultima_FechaActualizacion != null)
                {
                    str_Where += " AND convert(varchar, " + nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.fechaActualizacionInterna) + ",20)>=@FechaUltimaFechaActualizacion ";
                    lst_Parametros.Add(new SqlParameter("@FechaUltimaFechaActualizacion", _dtt_Ultima_FechaActualizacion.Value.ToString("yyyy-MM-dd HH:mm:ss")));
                }
                str_SQL = str_SQL.Replace("XXXXXXXXXX", str_Where);

                //Parametros
                object[] arr_Parametros = lst_Parametros.ToArray();


                //Rellenar el Modelo
                lst_INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo = obj_Exferia_Entities.Database.SqlQuery<INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo>(str_SQL, arr_Parametros).ToList();
                
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaAcumulados_Datos) + "/" + nameof(Obtener_Registros_Para_Listado_Por_UltimaFechaActualizacion), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo;
        }

        private string Obtener_Consulta_Para_Listado()
        {
            return 
                  " SELECT " +
                            nameof(INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo.id) + " = " + nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.id) + "," +
                            nameof(INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo.idInformeContableLinea) + " = " + nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.idInformeContableLinea) + "," +
                            nameof(INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo.idInformeContableLinea_Operacion) + " = " + nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.idInformeContableLinea_Operacion) + "," +
                            nameof(INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo.linea) + " = " + nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.linea) + "," +
                            nameof(INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo.calculo_valor) + " = " + nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.calculo_valor) + "," +
                            nameof(INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo.calculo_operacion) + " = " + nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.calculo_operacion) + "," +
                            nameof(INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo.operacion) + " = " + nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.operacion) + "," +
                            nameof(INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo.fechaActualizacionInterna) + " = " + nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.fechaActualizacionInterna) + "," +
                            nameof(INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo.fechaBorrado) + " =  " + nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.fechaBorrado) + "," +
                            //CTA_InformesContablesLinea(oPERACION)
                            nameof(INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo.LineaOperacion_Linea) + " = " + nameof(CTA_InformesContablesLinea) + "." + nameof(CTA_InformesContablesLinea.linea) + "," +
                            nameof(INTERNO_CTA_InformesContablesLineaAcumulados_Listado_Modelo.LineaOperacion_Descripcion) + " = " + nameof(CTA_InformesContablesLinea) + "." + nameof(CTA_InformesContablesLinea.descripcion) + 
                        " FROM " + nameof(CTA_InformesContablesLineaAcumulados) +
                        " INNER JOIN " + nameof(CTA_InformesContablesLinea) + " ON " + nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.idInformeContableLinea_Operacion) + " = " + nameof(CTA_InformesContablesLinea) + "." + nameof(CTA_InformesContablesLinea.id) +
                        //Where
                        " WHERE XXXXXXXXXX";
        }

        #endregion
        #endregion

        #region MODELOS

        #region Modelo Simple
        private CTA_InformesContablesLineaAcumulados g_mdl_CTA_InformesContablesLineaAcumulados = null;
        public CTA_InformesContablesLineaAcumulados Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " + nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaAcumulados_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_CTA_InformesContablesLineaAcumulados;
        }

        #region Ejecutar_Consulta_Modelo
        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                              object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_CTA_InformesContablesLineaAcumulados = obj_Exferia_Entities.Database.SqlQuery<CTA_InformesContablesLineaAcumulados>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaAcumulados_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }



        #endregion
        #endregion

        #region ModeloListado
        private List<CTA_InformesContablesLineaAcumulados> g_lst_CTA_InformesContablesLineaAcumulados = null;

        public List<CTA_InformesContablesLineaAcumulados> Obtener_ModeloListado_Por_IdInformeContableLinea( long _lng_idInformeContableLinea)
        {
            try
            {

                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.idInformeContableLinea) + "=@idInformeContableLinea";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idInformeContableLinea",  _lng_idInformeContableLinea)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaAcumulados_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdInformeContableLinea), true);
            }

            return g_lst_CTA_InformesContablesLineaAcumulados;
        }
        public List<CTA_InformesContablesLineaAcumulados> Obtener_ModeloListado_Por_IdsInformeContableLinea(List<long> _lst_idInformeContableLinea)
        {
            try
            {
                if (_lst_idInformeContableLinea != null && _lst_idInformeContableLinea.Count > 0)
                {

                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(CTA_InformesContablesLineaAcumulados),
                                                                                            nameof(CTA_InformesContablesLineaAcumulados.idInformeContableLinea),
                                                                                            G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                            _lst_idInformeContableLinea);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                       //WHERE
                                       " WHERE " +
                                            nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.fechaBorrado) + " is null and " +
                                            str_Filtros_IDS;

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { });

                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaAcumulados_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdsInformeContableLinea), true);
            }

            return g_lst_CTA_InformesContablesLineaAcumulados;
        }

        #region Ejecutar Consulta

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                      object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_CTA_InformesContablesLineaAcumulados = obj_Exferia_Entities.Database.SqlQuery<CTA_InformesContablesLineaAcumulados>(_str_SQL, _arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaAcumulados_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #endregion


        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.id) + " , " +
                    nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.idInformeContableLinea) + " , " +
                    nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.idInformeContableLinea_Operacion) + " , " +
                    nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.linea) + " , " +
                    nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.calculo_valor) + " , " +
                    nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.calculo_operacion) + " , " +
                    nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.operacion) + " , " +
                    nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.fechaActualizacionInterna) + " , " +
                    nameof(CTA_InformesContablesLineaAcumulados) + "." + nameof(CTA_InformesContablesLineaAcumulados.fechaBorrado) +
                " FROM " + nameof(CTA_InformesContablesLineaAcumulados);
        }
        #endregion
    
        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                CTA_InformesContablesLineaAcumulados mdl_CTA_InformesContablesLineaAcumulados_AGrabar = (CTA_InformesContablesLineaAcumulados)_mdl_obj;
                CTA_InformesContablesLineaAcumulados mdl_CTA_InformesContablesLineaAcumulados_DatosViejos = new CTA_InformesContablesLineaAcumulados();

                // Ver si existe ######################################################################
                CTA_InformesContablesLineaAcumulados mdl_CTA_InformesContablesLineaAcumulados_Final = Obtener_Modelo_Por_Id(mdl_CTA_InformesContablesLineaAcumulados_AGrabar.id);
                //######################################################################################

                if (mdl_CTA_InformesContablesLineaAcumulados_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_CTA_InformesContablesLineaAcumulados_Final, mdl_CTA_InformesContablesLineaAcumulados_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_CTA_InformesContablesLineaAcumulados_AGrabar, mdl_CTA_InformesContablesLineaAcumulados_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(CTA_InformesContablesLineaAcumulados) +
                                            " SET " +
                                                nameof(CTA_InformesContablesLineaAcumulados.idInformeContableLinea) + "=@idInformeContableLinea, " +
                                                nameof(CTA_InformesContablesLineaAcumulados.idInformeContableLinea_Operacion) + "=@idInformeContableLinea_Operacion, " +
                                                nameof(CTA_InformesContablesLineaAcumulados.linea) + "=@linea, " +
                                                nameof(CTA_InformesContablesLineaAcumulados.calculo_valor) + "=@calculo_valor, " +
                                                nameof(CTA_InformesContablesLineaAcumulados.calculo_operacion) + "=@calculo_operacion, " +
                                                nameof(CTA_InformesContablesLineaAcumulados.operacion) + "=@operacion, " +
                                                nameof(CTA_InformesContablesLineaAcumulados.fechaActualizacionInterna) + "=getdate()," +
                                                nameof(CTA_InformesContablesLineaAcumulados.fechaBorrado) + "=@fechaBorrado " +
                                                " WHERE " +
                                                nameof(CTA_InformesContablesLineaAcumulados.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@idInformeContableLinea",  mdl_CTA_InformesContablesLineaAcumulados_Final.idInformeContableLinea),
                        new SqlParameter("@idInformeContableLinea_Operacion",  mdl_CTA_InformesContablesLineaAcumulados_Final.idInformeContableLinea_Operacion),
                        new SqlParameter("@linea",  mdl_CTA_InformesContablesLineaAcumulados_Final.linea),
                        mdl_CTA_InformesContablesLineaAcumulados_Final.calculo_valor!=null
                            ?   new SqlParameter("@calculo_valor", mdl_CTA_InformesContablesLineaAcumulados_Final.calculo_valor.Value)
                            :   new SqlParameter("@calculo_valor",  DBNull.Value),
                        mdl_CTA_InformesContablesLineaAcumulados_Final.calculo_operacion!=null
                            ?   new SqlParameter("@calculo_operacion", mdl_CTA_InformesContablesLineaAcumulados_Final.calculo_operacion.Value)
                            :   new SqlParameter("@calculo_operacion",  DBNull.Value),
                        new SqlParameter("@operacion",  mdl_CTA_InformesContablesLineaAcumulados_Final.operacion),
                        mdl_CTA_InformesContablesLineaAcumulados_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_CTA_InformesContablesLineaAcumulados_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        new SqlParameter("@id",  mdl_CTA_InformesContablesLineaAcumulados_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_CTA_InformesContablesLineaAcumulados_Final.id;
                }
                else
                {
                    mdl_CTA_InformesContablesLineaAcumulados_Final = new CTA_InformesContablesLineaAcumulados();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_CTA_InformesContablesLineaAcumulados_AGrabar, mdl_CTA_InformesContablesLineaAcumulados_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(CTA_InformesContablesLineaAcumulados) +
                                                " (" +
                                                        nameof(CTA_InformesContablesLineaAcumulados.idInformeContableLinea) + "," +
                                                        nameof(CTA_InformesContablesLineaAcumulados.idInformeContableLinea_Operacion) + "," +
                                                        nameof(CTA_InformesContablesLineaAcumulados.linea) + "," +
                                                        nameof(CTA_InformesContablesLineaAcumulados.calculo_valor) + "," +
                                                        nameof(CTA_InformesContablesLineaAcumulados.calculo_operacion) + "," +
                                                        nameof(CTA_InformesContablesLineaAcumulados.operacion) + "," +
                                                        nameof(CTA_InformesContablesLineaAcumulados.fechaActualizacionInterna) + "," +
                                                        nameof(CTA_InformesContablesLineaAcumulados.fechaBorrado) + 
                                                " ) " +
                                                " OUTPUT INSERTED." + nameof(CTA_InformesContablesLineaAcumulados.id) +
                                                " VALUES " +
                                                " ( " +
                                                    "@idInformeContableLinea," +
                                                    "@idInformeContableLinea_Operacion," +
                                                    "@linea," +
                                                    "@calculo_valor," +
                                                    "@calculo_operacion," +
                                                    "@operacion," +
                                                    "getdate()," +
                                                    "@fechaBorrado" +
                                                " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@idInformeContableLinea",  mdl_CTA_InformesContablesLineaAcumulados_Final.idInformeContableLinea),
                         new SqlParameter("@idInformeContableLinea_Operacion",  mdl_CTA_InformesContablesLineaAcumulados_Final.idInformeContableLinea_Operacion),
                        new SqlParameter("@linea",  mdl_CTA_InformesContablesLineaAcumulados_Final.linea),
                        mdl_CTA_InformesContablesLineaAcumulados_Final.calculo_valor!=null
                            ?   new SqlParameter("@calculo_valor", mdl_CTA_InformesContablesLineaAcumulados_Final.calculo_valor.Value)
                            :   new SqlParameter("@calculo_valor",  DBNull.Value),
                        mdl_CTA_InformesContablesLineaAcumulados_Final.calculo_operacion!=null
                            ?   new SqlParameter("@calculo_operacion", mdl_CTA_InformesContablesLineaAcumulados_Final.calculo_operacion.Value)
                            :   new SqlParameter("@calculo_operacion",  DBNull.Value),
                        new SqlParameter("@operacion",  mdl_CTA_InformesContablesLineaAcumulados_Final.operacion),
                        mdl_CTA_InformesContablesLineaAcumulados_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_CTA_InformesContablesLineaAcumulados_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(CTA_InformesContablesLineaAcumulados), mdl_CTA_InformesContablesLineaAcumulados_DatosViejos, mdl_CTA_InformesContablesLineaAcumulados_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaAcumulados_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public void Actualizar_FechaActualizacionInterna(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                #region Update
                string str_SQL_Update = " UPDATE " + nameof(CTA_InformesContablesLineaAcumulados) +
                                            " SET " +
                                                nameof(CTA_InformesContablesLineaAcumulados.fechaActualizacionInterna) + "=getdate() " +
                                        " WHERE " +
                                            nameof(CTA_InformesContablesLineaAcumulados.id) + "=@id";
                //Parametros
                object[] arr_Parametros_Update = new object[]
                {
                    new SqlParameter("@id", _lng_id)
                };
                #endregion

                //Update
                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaAcumulados_Datos) + "/" + nameof(Actualizar_FechaActualizacionInterna), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        public void Actualizar_Lineas(long _lng_idInformeContableLinea, long _lng_idInformeContableLineaAcumulado_Obviar, int _int_Linea)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                #region Update
                string str_SQL_Update = " UPDATE " + nameof(CTA_InformesContablesLineaAcumulados) +
                                            " SET " +
                                                nameof(CTA_InformesContablesLineaAcumulados.linea) + "=(" + nameof(CTA_InformesContablesLineaAcumulados.linea) + " + 1), " +
                                                nameof(CTA_InformesContablesLineaAcumulados.fechaActualizacionInterna) + "=getdate() " +
                                        " WHERE " +
                                            nameof(CTA_InformesContablesLineaAcumulados.idInformeContableLinea) + "=@idInformeContableLinea AND " +
                                            nameof(CTA_InformesContablesLineaAcumulados.id) + "<>@id AND " +
                                            nameof(CTA_InformesContablesLineaAcumulados.linea) + ">=@linea";
                //Parametros
                object[] arr_Parametros_Update = new object[]
                {
                    new SqlParameter("@idInformeContableLinea", _lng_idInformeContableLinea),
                    new SqlParameter("@id", _lng_idInformeContableLineaAcumulado_Obviar),
                    new SqlParameter("@linea", _int_Linea)
                };
                #endregion

                //Update
                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaAcumulados_Datos) + "/" + nameof(Actualizar_Lineas), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                CTA_InformesContablesLineaAcumulados mdl_CTA_InformesContablesLineaAcumulados_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_CTA_InformesContablesLineaAcumulados_Final != null)
                {
                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(CTA_InformesContablesLineaAcumulados) +
                                                " SET " +
                                                nameof(CTA_InformesContablesLineaAcumulados.fechaBorrado) + "=@fechaBorrado, " +
                                                nameof(CTA_InformesContablesLineaAcumulados.fechaActualizacionInterna) + "=getdate() " +
                                            " WHERE " +
                                                nameof(CTA_InformesContablesLineaAcumulados.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                                new SqlParameter("@fechaBorrado",  DateTime.Now),
                            new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Grabar un registro de trazabilidad con los datos de la trasaccion realizada
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(CTA_InformesContablesLineaAcumulados), null, mdl_CTA_InformesContablesLineaAcumulados_Final, G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);

                }

                //Devolver tambien el Objeto
                mdl_INTERNO_ValorDevuelto_Modelo.Id = _lng_id;
  
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaAcumulados_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                List<long> lst_idInformeContableLinea = (List<long>)_mdl_obj;

                if (lst_idInformeContableLinea != null & lst_idInformeContableLinea.Count > 0)
                {
                    List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                    string str_Fitros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(lst_idInformeContableLinea);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(CTA_InformesContablesLineaAcumulados) +
                                                " SET " +
                                                nameof(CTA_InformesContablesLineaAcumulados.fechaBorrado) + "=@fechaBorrado, " +
                                                nameof(CTA_InformesContablesLineaAcumulados.fechaActualizacionInterna) + "=getdate() " +
                                            " WHERE " + nameof(CTA_InformesContablesLineaAcumulados.id) + " in (" + str_Fitros_IDS + ")";
                    //Parametros
                    lst_Parametros.Add(new SqlParameter("@fechaBorrado", DateTime.Now));
                    object[] arr_Parametros = lst_Parametros.ToArray();
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros);

                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_InformesContablesLineaAcumulados_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

    }

}
